#include "stdafx.h"
#include "tinyxml2/tinyxml2.h"
#include "LuaCfgHelper.h"
#include <iostream>
#include <boost/algorithm/string.hpp>
#include "Fish_JumpCFG.h"
std::auto_ptr<Fish_JumpCFG> Fish_JumpCFG::msSingleton(nullptr);

int Fish_JumpCFG::GetCount()
{
	return (int)mMapData.size();
}

const Fish_JumpCFGData* Fish_JumpCFG::GetData(int ID)
{
	auto it = mMapData.find(ID);
	if (it != mMapData.end())
	{
		return &it->second;
	}
	return NULL;
}

const std::map<int, Fish_JumpCFGData>& Fish_JumpCFG::GetMapData()
{
	return mMapData;
}

void Fish_JumpCFG::Load()
{
	tinyxml2::XMLDocument xmlDoc;
	std::string content = FileUtils::getInstance()->getStringFromFile("Config/Fish_JumpCFG.xml");
	auto result = xmlDoc.Parse(content.c_str(), content.length());
	if (result != tinyxml2::XML_SUCCESS)
	{
		CCLOGERROR("Result:%d", result);
		CCASSERT(false, "result != tinyxml2::XML_SUCCESS");
		return;
	}
	auto root = xmlDoc.RootElement();
	if (root == NULL)
	{
		CCASSERT(false, "root == NULL");
		return;
	}
	auto element = root->FirstChildElement("Data");
	while (element != NULL)
	{
		Fish_JumpCFGData data;
		data.mID = element->IntAttribute("ID");
		data.mType = element->IntAttribute("Type");
		data.m图标1 = element->Attribute("图标1");
		data.m图标2 = element->Attribute("图标2");
		data.m图标3 = element->Attribute("图标3");
		data.m图标4 = element->Attribute("图标4");
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		element = element->NextSiblingElement();
	}
	CCLOG("Fish_JumpCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JumpCFG::LoadLua()
{
	LuaEngine::getInstance()->executeScriptFile("config/Fish_JumpCFG");
	lua_State* L = LuaEngine::getInstance()->getLuaStack()->getLuaState();
	lua_getglobal(L, "Fish_JumpCFG");
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushstring(L, "datas");
	lua_gettable(L, -2);
	CCASSERT(lua_istable(L, -1) == 1, "is not table");
	lua_pushnil(L);
	while(lua_next(L, 2))
	{
		CCASSERT(lua_istable(L, -1) == 1, "is not table");
		Fish_JumpCFGData data;
		LuaCfgHelper::readInt(L, "ID", data.mID);
		LuaCfgHelper::readInt(L, "Type", data.mType);
		LuaCfgHelper::readString(L, "图标1", data.m图标1);
		LuaCfgHelper::readString(L, "图标2", data.m图标2);
		LuaCfgHelper::readString(L, "图标3", data.m图标3);
		LuaCfgHelper::readString(L, "图标4", data.m图标4);
		if (mMapData.find(data.mID) != mMapData.end())std::cout <<"data refind:" << data.mID << std::endl;
		CCASSERT(mMapData.find(data.mID) == mMapData.end(), "data.mID is exists");
		mMapData.insert(std::make_pair(data.mID, data));
		lua_pop(L, 1);
	}
	lua_settop(L, 0);
	CCLOG("Fish_JumpCFG Loaded. Load Data:%u", mMapData.size());
}

void Fish_JumpCFG::Reload()
{
	mMapData.clear();
	Load();
}

Fish_JumpCFG* Fish_JumpCFG::GetSingleton()
{
	if (msSingleton.get() == nullptr)
	{
		msSingleton.reset(new Fish_JumpCFG());
	}
	return msSingleton.get();
}

void Fish_JumpCFG::Release()
{
	msSingleton.reset(nullptr);
}
